%{

/*
 * scan.l -- scanner for demonstration program
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "demo.h"

%}

D		[0-9]
INT		{D}+
EXP		e(\+|\-)?{INT}
NUM		({INT}\.?|{INT}?\.{INT}){EXP}?
VAR		[a-z]


%%


[\ \t]		{
		  /* nothing to do here */
		}

{NUM}		{
		  yylval.value = strtod(yytext, NULL);
		  return NUMBER;
		}

{VAR}		{
		  yylval.index = yytext[0] - 'a';
		  return VAR;
		}

\n		{
		  return NEWLINE;
		}

\+		{
		  return PLUS;
		}

\-		{
		  return MINUS;
		}

\*		{
		  return STAR;
		}

\/		{
		  return SLASH;
		}

\(		{
		  return LPAREN;
		}

\)		{
		  return RPAREN;
		}

\-\>		{
		  return STORE;
		}

.		{
		  printf("illegal character '%c' (0x%02X)\n",
		         yytext[0], yytext[0]);
		  exit(99);
		}


%%


int yywrap(void) {
  return 1;
}
